@echo off
setlocal enabledelayedexpansion

if /i "%processor_architecture%"=="AMD64" (GOTO AMD64)
if /i "%PROCESSOR_ARCHITEW6432%"=="AMD64" (GOTO AMD64)
    rem only defined in WoW64 processes
if /i "%processor_architecture%"=="x86" (GOTO x86) else (GOTO ERR_arch)

:AMD64
    rem @echo 64bit system
    SET selectDir=%~dp0\amd64
 GOTO EXEC

:x86
    rem @echo 32bit system
    SET selectDir=%~dp0\x86
 GOTO EXEC

:EXEC
    rem do arch independent stuff
    @echo %selectDir%
    cd %selectDir%

    rem 1) remove driver packages from store
    rem ------------------------------------
    @echo *******************************************
    @echo *** Please allow access for dpinst.exe  ***
    @echo ***    You may be asked several times   ***
    @echo ***    to get all unused items removed. ***
    @echo *******************************************
    @echo removing unused ... 
    for /f "delims=" %%f in ('dir ..\old_remove /b') do (
        set rmID=..\old_remove\%%f
        @echo %%f
        dpinst.exe /u !rmID!
        )

    rem 2) force-remove active VID_PID pairs 
    rem ------------------------------------
    if exist fpqports.txt DEL fpqports.txt
    if exist remove.txt DEL remove.txt
    devcon findall =ports "USB\VID_0F7E&PID_900A*" >> fpqports.txt
    devcon findall =ports "USB\VID_0F7E&PID_900C*" >> fpqports.txt
    devcon findall =ports "USB\VID_0F7E&PID_900F*" >> fpqports.txt
    devcon findall =ports "USB\VID_0F7E&PID_9020*" >> fpqports.txt
    
    rem strip devcon messages from search results
    findstr /c:"VID_0F7E" fpqports.txt >> remove.txt
    
    rem force-remove found items
    for /F "tokens=1,2* delims= " %%i in (remove.txt) do (
        set rmID=^@^"%%i^"
        devcon -r -f remove =ports !rmID!
        )
	
    rem 3) add new pacakge
    rem ------------------
    @echo adding new ... 
    dpinst.exe /PATH ..\new_add /F
    rem found reboot to always be required when testing on VKa PC.
    rem therefor skipping errorlevel decoding 
    rem (dpinst returns 0x04000000 flag to indicate reboot is required)

    rem 4) rescan
    rem ---------
    devcon rescan
	
    @echo *****************************
    @echo *** Please reboot your PC ***
    @echo *****************************
    pause
 GOTO END
 
:ERR_arch
    @echo Unable to detect architecture!
    pause
 GOTO END
 
:ERR_inst
    rem unused see note under EXEC:
    @echo Error installing latest driver. 
    pause
 GOTO END

:END
    cd .. 